<div class="container-fluid" >
  <div class="col-md-12">
    <div class="box">
      <div class="box-header with-border">
        <div class="row">
          <div class="col-sm-8">
            <h3 class="box-title">Transfer Budget Detail</h3>
          </div>
          <div class="col-sm-4" *ngIf="requestedByUserId === currentUserId">
            <button class="btn btn-success btn-xs fa-pull-right"
                    (click)="addNewEntry()"> Add New </button>
          </div>
        </div>
      </div>
      <!-- /.box-header -->
      <div class="box-body" *ngIf="data$">
        <p-table id="exportTable"
                 class="text-left"
                 [columns]="columnName"
                 [value]="(data$)"
                 [resizableColumns]="true"
                 [autoLayout]="true">
          <ng-template pTemplate="caption">
            <div class="row">
              <div class="col-sm-12">
                <span>
                    List of Payment
                :&nbsp;{{ data$.length }}
                </span>
              </div>
            </div>
          </ng-template>
          <ng-template pTemplate="header" let-columns>
            <tr>
              <th *ngFor="let col of columns" [pSortableColumn]="col.value">
                {{col.name}}
                <p-sortIcon [field]="col.value"></p-sortIcon>
              </th>
            </tr>
          </ng-template>

          <ng-template pTemplate="body" let-list let-i="rowIndex">
            <tr [ngStyle]="{'background-color':i%2 === 0 ? '#fafafa' : '#e9ecef'}">
              <td>{{ i + 1 }}</td>
              <td>{{ list.fromFiscalYear}}</td>
              <td>{{ list.fromMonth }}</td>
              <td>{{ list.fromBranch}}</td>
              <td>{{ list.fromAccountHead }}</td>
              <td>{{ list.toFiscalYear }}</td>
              <td>{{ list.toMonth }}</td>
              <td>{{ list.toBranch }}</td>
              <td>{{ list.toAccountHead }}</td>
              <td>{{ list.amount }}</td>
              <td>{{ list.transferStatus }}</td>
              <td>
                <span *ngIf="list.requestedBy === currentUserId">
                    <p-inputSwitch
                      [name]="list.status"
                      [inputId]="list.status"
                      (onChange)="handleChange($event, list.budgetTransferDetailId)"
                      [ngModel]="list.status === 'ACTIVE'? true: false ">
                    </p-inputSwitch>
                </span>
                <span *ngIf="list.requestedBy !== currentUserId">{{list.status}}</span>
              </td>
              <td>
                <button class="btn btn-info btn-xs"
                        (click)="editAmount(list)"
                        *ngIf="list.requestedBy === currentUserId">
                  Edit <i class="pi pi-pencil"></i>
                </button>
              </td>
            </tr>
          </ng-template>
        </p-table>
      </div>
    </div>
  </div>
</div>


<p-dialog [(visible)]="showEditAmountForm"
          [modal]="true"
          [responsive]="true"
          [maximizable]="true"
          [baseZIndex]="100000"
          [style]="{width: '490px', height: 'auto'}">
  <p-header>
    Update Amount
  </p-header>
  <div class="row" *ngIf="editAmountFormDetail">
    <div class="col-md-12 mt-3">
      <strong>From Detail</strong>
      <hr>
      <div class="col-md-6 form-group float-left">
        <label>Fiscal Year :</label>
        <p>{{ editAmountFormDetail.fromFiscalYear }}</p>
      </div>
      <div class="col-md-6 form-group float-left">
        <label>Month:</label>
        <p>{{ editAmountFormDetail.fromMonth }}</p>
      </div>
      <div class="col-md-6 form-group float-left">
        <label>Branch:</label>
        <p>{{ editAmountFormDetail.fromBranch }}</p>
      </div>
      <div class="col-md-6 form-group float-left">
        <label>Account Head:</label>
        <p>{{ editAmountFormDetail.fromAccountHead }}</p>
      </div>
    </div>
    <div class="col-md-12 mt-3">
      <strong>To Detail</strong>
      <hr>
      <div class="col-md-6 form-group float-left">
        <label>Fiscal Year :</label>
        <p>{{ editAmountFormDetail.toFiscalYear }}</p>
      </div>
      <div class="col-md-6 form-group float-left">
        <label>Month:</label>
        <p>{{ editAmountFormDetail.toMonth }}</p>
      </div>
      <div class="col-md-6 form-group float-left">
        <label>Branch:</label>
        <p>{{ editAmountFormDetail.toBranch }}</p>
      </div>
      <div class="col-md-6 form-group float-left">
        <label>Account Head:</label>
        <p>{{ editAmountFormDetail.toAccountHead }}</p>
      </div>
    </div>
  </div>

  <form [formGroup]="updateBudgetTransferDetailForm">
    <div class="form-group">
      <label for="amount">Amount<span class="required">*</span></label>
      <input type="text"
             id="amount"
             formControlName="amount"
             class="form-control"
             placeholder="Max length 50 Characters"
             [ngClass]="{ 'is-invalid': submitted && f.amount.errors }"
             maxlength="50"
             required>
      <div *ngIf="submitted && f.amount.errors" class="invalid-feedback">
        <div *ngIf="f.amount.errors.required">Amount is required</div>
      </div>
    </div>

    <div class="form-group">
      <div class="row">
        <div class="col-sm-6">
          <button class="btn btn-success btn-xs btn-block" (click)="submitUploadForm()">
            Submit
            <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
          </button>
        </div>
        <div class="col-sm-6">
          <button class="btn btn-danger btn-xs btn-block" (click)="cancelSubmit()"> Cancel</button>
        </div>
      </div>
    </div>
  </form>
</p-dialog>



<p-dialog [(visible)]="displayBudgetTransferForm"
          [modal]="true"
          [responsive]="true"
          [maximizable]="true"
          [baseZIndex]="100000"
          [style]="{width: '490px', height: 'auto'}">
  <p-header>
    Transfer Budget
  </p-header>
  <form [formGroup]="budgetTransferForm">
    <div class="row">
      <div class="col-sm-6">
        <h3>From Branch Budget</h3>
        <div class="form-group">
          <label for="fromFiscalYearId">Fiscal Year</label>
          <select id="fromFiscalYearId"
                  class="form-control"
                  formControlName="fromFiscalYearId"
                  [ngClass]="{ 'is-invalid': submitted && ff.fromFiscalYearId.errors }"
                  name="fromFiscalYearId">
            <option *ngFor="let event of (fiscalYears); let i = index"
                    [ngValue]="(fiscalYears)[i].id"
            >{{(fiscalYears)[i].year }}</option>
          </select>
          <div *ngIf="submitted && ff.fromFiscalYearId.errors" class="invalid-feedback">
            <div *ngIf="ff.fromFiscalYearId.errors.required">Fiscal Year is Required.</div>
          </div>
        </div>
        <div class="form-group">
          <label for="fromMonth">Month</label>
          <select id="fromMonth"
                  class="form-control"
                  formControlName="fromMonth"
                  [ngClass]="{ 'is-invalid': submitted && ff.fromMonth.errors }"
                  name="fromMonth">
            <option *ngFor="let event of (months); let i = index"
                    [ngValue]="(months)[i].months"
            >{{(months)[i].months }}</option>
          </select>
          <div *ngIf="submitted && ff.fromMonth.errors" class="invalid-feedback">
            <div *ngIf="ff.fromMonth.errors.required">Month is Required.</div>
          </div>
        </div>

        <div class="form-group">
          <label for="fromBranchId">Branch</label>
          <select id="fromBranchId"
                  class="form-control"
                  formControlName="fromBranchId"
                  [ngClass]="{ 'is-invalid': submitted && ff.fromBranchId.errors }"
                  name="fromBranchId">
            <option *ngFor="let event of (branches); let i = index"
                    [ngValue]="(branches)[i].branchId"
            >{{(branches)[i].name }}</option>
          </select>
          <div *ngIf="submitted && ff.fromBranchId.errors" class="invalid-feedback">
            <div *ngIf="ff.fromBranchId.errors.required"> Branch is Required.</div>
          </div>
        </div>

        <div class="form-group">
          <label for="fromAccountHeadId">Account Head</label>
          <select id="fromAccountHeadId"
                  class="form-control"
                  formControlName="fromAccountHeadId"
                  [ngClass]="{ 'is-invalid': submitted && ff.fromAccountHeadId.errors }"
                  name="fromAccountHeadId">
            <option *ngFor="let event of (accountHeads); let i = index"
                    [ngValue]="(accountHeads)[i].accountHeadId"
            >{{(accountHeads)[i].description + '( ' + (accountHeads)[i].accountNumber + ')' }}</option>
          </select>
          <div *ngIf="submitted && ff.fromAccountHeadId.errors" class="invalid-feedback">
            <div *ngIf="ff.fromAccountHeadId.errors.required">Account Head required.</div>
          </div>
        </div>
      </div>
      <div class="col-sm-6">
        <h3>To Branch Budget</h3>
        <div class="form-group">
          <label for="toFiscalYearId">Fiscal Year<span class="required">*</span></label>
          <select id="toFiscalYearId"
                  class="form-control"
                  formControlName="toFiscalYearId"
                  [ngClass]="{ 'is-invalid': submitted && ff.toFiscalYearId.errors }"
                  name="toFiscalYearId">
            <option *ngFor="let event of (fiscalYears); let i = index"
                    [ngValue]="(fiscalYears)[i].id"
            >{{(fiscalYears)[i].year }}</option>
          </select>
          <div *ngIf="submitted && ff.toFiscalYearId.errors" class="invalid-feedback">
            <div *ngIf="ff.toFiscalYearId.errors.required">Fiscal Year is Required.</div>
          </div>
        </div>
        <div class="form-group">
          <label for="toMonth">Month<span class="required">*</span></label>
          <select id="toMonth"
                  class="form-control"
                  formControlName="toMonth"
                  [ngClass]="{ 'is-invalid': submitted && ff.toMonth.errors }"
                  name="toMonth">
            <option *ngFor="let event of (months); let i = index"
                    [ngValue]="(months)[i].months"
            >{{(months)[i].months }}</option>
          </select>
          <div *ngIf="submitted && ff.toMonth.errors" class="invalid-feedback">
            <div *ngIf="ff.toMonth.errors.required">Month is Required.</div>
          </div>
        </div>

        <div class="form-group">
          <label for="toBranchId">Branch<span class="required">*</span></label>
          <select id="toBranchId"
                  class="form-control"
                  formControlName="toBranchId"
                  [ngClass]="{ 'is-invalid': submitted && ff.toBranchId.errors }"
                  name="toBranchId">
            <option *ngFor="let event of (branches); let i = index"
                    [ngValue]="(branches)[i].branchId"
            >{{(branches)[i].name }}</option>
          </select>
          <div *ngIf="submitted && ff.toBranchId.errors" class="invalid-feedback">
            <div *ngIf="ff.toBranchId.errors.required"> Branch is Required.</div>
          </div>
        </div>

        <div class="form-group">
          <label for="toAccountHeadId">Account Head<span class="required">*</span></label>
          <select id="toAccountHeadId"
                  class="form-control"
                  formControlName="toAccountHeadId"
                  [ngClass]="{ 'is-invalid': submitted && ff.toAccountHeadId.errors }"
                  name="toAccountHeadId">
            <option *ngFor="let event of (accountHeads); let i = index"
                    [ngValue]="(accountHeads)[i].accountHeadId"
            >{{(accountHeads)[i].description + '( ' + (accountHeads)[i].accountNumber + ')' }}</option>
          </select>
          <div *ngIf="submitted && ff.toAccountHeadId.errors" class="invalid-feedback">
            <div *ngIf="ff.toAccountHeadId.errors.required">Account Head required.</div>
          </div>
        </div>
      </div>
    </div>
    <div class="form-group">
      <label for="amount1">Budget<span class="required">*</span></label>
      <input type="number"
             class="form-control"
             id="amount1"
             placeholder="Enter Amount to be Transferred"
             [ngClass]="{ 'is-invalid': submitted && ff.amount.errors }"
             formControlName="amount"
             required
      >
      <div *ngIf="submitted && ff.amount.errors" class="invalid-feedback">
        <div *ngIf="ff.amount.errors.required">Amount to be transferred is required.</div>
      </div>
    </div>
    <p-footer>
      <div class="row">
        <div class="col-sm-6">
          <button class="btn btn-danger btn-block"
                  (click)="cancelTransfer()"> Cancel</button>
        </div>
        <div class="col-sm-6">
          <button class="btn btn-success btn-block"
                  (click)="submitTransfer()"
                  type="submit">
            <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
            Submit
          </button>
        </div>
      </div>
    </p-footer>
  </form>
</p-dialog>

